/**
 * @file
 */

(function ($) {

  window.didomiOnReady = window.didomiOnReady || [];
  window.didomiOnReady.push(function (Didomi) {
    // I'm not sure if it is necessary. Did not test.
    if (!Didomi.isConsentRequired()) {
      return;
    }

    $('script[type="didomi/html"]').once('didomi-engagement', function () {
      var $this = $(this);
      var vendor = Didomi.getVendorById($this.attr('data-vendor'));

      var consent = Didomi.getUserConsentStatusForVendor(vendor.id);
      if (consent) {
        for (var i = 0; i < vendor.purposeIds.length; i++) {
          if (!Didomi.getUserConsentStatusForPurpose(vendor.purposeIds[i])) {
            consent = false;
            break;
          }
        }
      }

      // If the user has given consent for the vendor and all purposes, nothing
      // to display here.
      if (consent) {
        return;
      }

      var $div = $('<div class="didomi-engagement"></div>');
      $div.css({'position': 'relative', 'width': $this.css('width'), 'height': $this.css('height')});
      $div.html('<div class="engagement">' + Drupal.theme('didomiEngagement', vendor) + '</div>');
      var $button = $('<button class="didomi-accept">' + Drupal.t('Accept') + '</button>');
      $button.data('vendor', vendor.id);
      $button.click(function () {
        var vendor = Didomi.getVendorById($(this).data('vendor'));
        var transaction = Didomi.openTransaction();
        transaction.enableVendor(vendor.id);
        for (var i = 0; i < vendor.purposeIds.length; i++) {
          transaction.enablePurpose(vendor.purposeIds[i]);
        }
        transaction.commit();
        $(this).parents('.didomi-engagement').remove();
      });
      $div.append($button);
      $this.after($div);
    });
  });

  Drupal.theme.prototype.didomiEngagement = function(vendor) {
    var purposes = vendor.purposeIds.map(function (purposeId) {
      var name = Didomi.getPurposeById(purposeId).name;
      var lang = $('html').attr('lang');
      if (typeof name[lang] === 'undefined') {
        lang = Object.keys(name)[0];
      }
      return name[lang];
    });
    return Drupal.t('You must accept cookies from @vendor (@purposes) to view this content.', {
      '@vendor': vendor.name,
      '@purposes': purposes.join(', '),
    });
  }

})(jQuery);
